#ifndef FSGUI_DUTIL_IS_INCLUDED
#define FSGUI_DUTIL_IS_INCLUDED
/* { */

#include <ysclass.h>

/*! This function calculates a triangle that can be drawn as an arrowhead of a line 
    segment from p1 to p2 that appears to be the size of lengthInPixel and widthInPixel.  */
YSRESULT FsGui3DGetArrowHeadTriangle(
    YsVec3 plg[3],YsVec3 p1,YsVec3 p2,
    const int viewport[4],const YsMatrix4x4 &projMat,const YsMatrix4x4 &modelViewMat,const double nearz,
    const double lengthInPixel,const double widthInPixel);

/*! This function calculates a vector that will be one pixel from the projected position of point p. */
YSRESULT FsGui3DGetPixelVector(
    YsVec3 &xVec,YsVec3 &yVec,const YsVec3 &p,
    const int viewport[4],const YsMatrix4x4 &projMat,const YsMatrix4x4 &modelViewMat,const double nearz);

/*! This function returns five points that will draw a fixed-size star on the screen. */
YSRESULT FsGui3DGetStarPoint(
    YsVec3 plg[5],const YsVec3 &p,
    const int viewport[4],const YsMatrix4x4 &projMat,const YsMatrix4x4 &modelViewMat,const double nearz,
    const double iconSize);

/*! This function returns five points that will draw a fixed-size star on the screen. */
YSRESULT FsGui3DGetRectPoint(
    YsVec3 plg[4],const YsVec3 &p,
    const int viewport[4],const YsMatrix4x4 &projMat,const YsMatrix4x4 &modelViewMat,const double nearz,
    const double iconSize);

/*! This function returns five points that will draw a fixed-size star on the screen.  The length of the array plg must 
    be at least nDiv.  */
YSRESULT FsGui3DGetCirclePoint(
    YsVec3 plg[],int nDiv,const YsVec3 &p,
    const int viewport[4],const YsMatrix4x4 &projMat,const YsMatrix4x4 &modelViewMat,const double nearz,
    const double iconSize);

/* } */
#endif
