#include <ysclass.h>
#include <windows.h>
#include <mmsystem.h>
#include <d3dx9.h>

#include <ysd3d.h>

#include <ysbitmap.h>
#include "fsgui.h"
#include "fsguicommondrawing.h"



extern YsD3dDevice *ysD3dDev;

void FsGuiCommonDrawing::DrawLine(double x1,double y1,double x2,double y2,const YsColor &col)
{
	if(ysD3dDev!=NULL)
	{
		D3DXVECTOR2 rect[2];
		rect[0].x=(float)x1;
		rect[0].y=(float)y1;
		rect[1].x=(float)x2;
		rect[1].y=(float)y2;
		ysD3dDev->d3dLine->Draw(rect,2,D3DCOLOR_ARGB(col.Ai(),col.Ri(),col.Gi(),col.Bi()));
	}

	/* if(ysD3dDev!=NULL)
	{
		FsD3dDevice *fsD3dDev;
		fsD3dDev=(FsD3dDevice *)ysD3dDev;
		if(fsD3dDev->line2d!=NULL)
		{
			fsD3dDev->line2d->Add(D3DPT_LINELIST,(double)x1,(double)y1,0.5,col.Ri(),col.Gi(),col.Bi(),255);
			fsD3dDev->line2d->Add(D3DPT_LINELIST,(double)x2,(double)y2,0.5,col.Ri(),col.Gi(),col.Bi(),255);
		}
	} */
}

void FsGuiCommonDrawing::DrawLineStrip(int n,const double plg[],const YsColor &col)
{
	if(ysD3dDev!=NULL)
	{
		for(int i=0; i<n; i++)
		{
			ysD3dDev->AddXyzCol(D3DPT_LINESTRIP,(double)plg[i*2],(double)plg[i*2+1],0.5,col.Ri(),col.Gi(),col.Bi(),col.Ai());
		}
		ysD3dDev->FlushXyzCol(D3DPT_LINESTRIP);
	}
}

void FsGuiCommonDrawing::DrawRect(double x1,double y1,double x2,double y2,const YsColor &col,YSBOOL fill)
{
	if(ysD3dDev!=NULL)
	{
		if(fill==YSTRUE)
		{
			// int wid,hei;
			// FsGetWindowSize(wid,hei);

			// IDirect3DSurface9 *pSurface;
			// RECT rc;
			// rc.left=YsSmaller(x1,x2);
			// rc.right=YsGreater(x1,x2);
			// rc.top=YsSmaller(y1,y2);
			// rc.bottom=YsGreater(y1,y2);

			// rc.left=YsGreater <int> (rc.left,0);
			// rc.top=YsGreater <int> (rc.top,0);
			// rc.right=YsSmaller <int> (rc.right,wid);
			// rc.bottom=YsSmaller <int> (rc.bottom,hei);

			// if(ysD3dDev->d3dDev->GetBackBuffer(0,0,D3DBACKBUFFER_TYPE_MONO,&pSurface)==D3D_OK)
			// {
			// 	ysD3dDev->d3dDev->ColorFill(pSurface,&rc,D3DCOLOR_XRGB(col.Ri(),col.Gi(),col.Bi()));
			// 	pSurface->Release();
			// }

			// Alternative
			ysD3dDev->AddXyzCol(D3DPT_TRIANGLEFAN,(double)x1,(double)y1,0.5,col.Ri(),col.Gi(),col.Bi(),col.Ai());
			ysD3dDev->AddXyzCol(D3DPT_TRIANGLEFAN,(double)x2,(double)y1,0.5,col.Ri(),col.Gi(),col.Bi(),col.Ai());
			ysD3dDev->AddXyzCol(D3DPT_TRIANGLEFAN,(double)x2,(double)y2,0.5,col.Ri(),col.Gi(),col.Bi(),col.Ai());
			ysD3dDev->AddXyzCol(D3DPT_TRIANGLEFAN,(double)x1,(double)y2,0.5,col.Ri(),col.Gi(),col.Bi(),col.Ai());
			ysD3dDev->FlushXyzCol(D3DPT_TRIANGLEFAN);
		}
		else
		{
			D3DXVECTOR2 rect[5];
			rect[0].x=(float)x1;
			rect[0].y=(float)y1;
			rect[1].x=(float)x2;
			rect[1].y=(float)y1;
			rect[2].x=(float)x2;
			rect[2].y=(float)y2;
			rect[3].x=(float)x1;
			rect[3].y=(float)y2;
			rect[4].x=(float)x1;
			rect[4].y=(float)y1;
			ysD3dDev->d3dLine->Draw(rect,5,D3DCOLOR_ARGB(col.Ai(),col.Ri(),col.Gi(),col.Bi()));

			// Alternative
			// ysD3dDev->AddXyzCol(D3DPT_LINESTRIP,(double)x1,(double)y1,0.5,col.Ri(),col.Gi(),col.Bi(),255);
			// ysD3dDev->AddXyzCol(D3DPT_LINESTRIP,(double)x2,(double)y1,0.5,col.Ri(),col.Gi(),col.Bi(),255);
			// ysD3dDev->AddXyzCol(D3DPT_LINESTRIP,(double)x2,(double)y2,0.5,col.Ri(),col.Gi(),col.Bi(),255);
			// ysD3dDev->AddXyzCol(D3DPT_LINESTRIP,(double)x1,(double)y2,0.5,col.Ri(),col.Gi(),col.Bi(),255);
			// ysD3dDev->AddXyzCol(D3DPT_LINESTRIP,(double)x1,(double)y1,0.5,col.Ri(),col.Gi(),col.Bi(),255);
			// ysD3dDev->FlushXyzCol(D3DPT_LINESTRIP);
		}
	}
}

void FsGuiCommonDrawing::DrawCircle(double x,double y,double rad,const YsColor &col,YSBOOL fill)
{
	if(ysD3dDev!=NULL)
	{
		static YsArray <YsVec2> circle;
		D3DXVECTOR2 rect[65];

		if(circle.GetN()<65)
		{
			circle.Set(65,NULL);
			for(int i=0; i<=64; i++)
			{
				const double a=YsPi*((double)i)/32.0;
				circle[i].Set(cos(a),sin(a));
			}
		}


		if(fill==YSTRUE)
		{
			for(int i=0; i<64; i++)
			{
				float xx,yy;
				xx=(float)circle[i].x()*(float)rad+(float)x;
				yy=(float)circle[i].y()*(float)rad+(float)y;
				ysD3dDev->AddXyzCol(D3DPT_TRIANGLEFAN,(double)xx,(double)yy,0.5,col.Ri(),col.Gi(),col.Bi(),col.Ai());
			}
			ysD3dDev->FlushXyzCol(D3DPT_TRIANGLEFAN);
		}
		else
		{
			for(int i=0; i<65; i++)
			{
				rect[i].x=(float)circle[i].x()*(float)rad+(float)x;
				rect[i].y=(float)circle[i].y()*(float)rad+(float)y;
			}
			ysD3dDev->d3dLine->Draw(rect,65,D3DCOLOR_ARGB(col.Ai(),col.Ri(),col.Gi(),col.Bi()));
		}
	}
}

void FsGuiCommonDrawing::DrawPolygon(int n,const double plg[],const YsColor &col)
{
	if(ysD3dDev!=NULL)
	{
		for(int i=0; i<n; i++)
		{
			ysD3dDev->AddXyzCol(D3DPT_TRIANGLEFAN,(double)plg[i*2],(double)plg[i*2+1],0.5,col.Ri(),col.Gi(),col.Bi(),col.Ai());
		}
		ysD3dDev->FlushXyzCol(D3DPT_TRIANGLEFAN);
	}
}

void FsGuiCommonDrawing::DrawGradationPolygon(int n,const double plg[],const YsColor col[])
{
	if(ysD3dDev!=NULL)
	{
		for(int i=0; i<n; i++)
		{
			ysD3dDev->AddXyzCol(D3DPT_TRIANGLEFAN,(double)plg[i*2],(double)plg[i*2+1],0.5,col[i].Ri(),col[i].Gi(),col[i].Bi(),col[i].Ai());
		}
		ysD3dDev->FlushXyzCol(D3DPT_TRIANGLEFAN);
	}
}

void FsGuiCommonDrawing::DrawBmp(const YsBitmap &bmp,double sx,double sy)
{
	if(ysD3dDev!=NULL)
	{
		IDirect3DTexture9 *tex,*texCopy;
		// ID3DXSprite *sprite;

		if(D3DXCreateTexture
		   (ysD3dDev->d3dDev,bmp.GetWidth(),bmp.GetHeight(),D3DX_DEFAULT,0,
		    D3DFMT_A8R8G8B8,D3DPOOL_SYSTEMMEM,&tex)==D3D_OK)
		{
			if(D3DXCreateTexture
			   (ysD3dDev->d3dDev,bmp.GetWidth(),bmp.GetHeight(),D3DX_DEFAULT,0,
			    D3DFMT_A8R8G8B8,D3DPOOL_DEFAULT,&texCopy)!=D3D_OK)
			{
				tex->Release();
				return;
			}



			D3DLOCKED_RECT locked;
			RECT rect;
			const int level=0;

			rect.left=0;
			rect.top=0;
			rect.right=bmp.GetWidth();
			rect.bottom=bmp.GetHeight();
			if(tex->LockRect(level,&locked,&rect,D3DLOCK_DISCARD)==D3D_OK)
			{
				int x,y;
				unsigned char *buf,*dstTop;
				const unsigned char *srcTop;
				buf=(unsigned char *)locked.pBits;

				for(y=0; y<bmp.GetHeight(); y++)
				{
					dstTop=buf+y*locked.Pitch;
					srcTop=bmp.GetRGBAPixelPointer(0,bmp.GetHeight()-1-y);

					// memcpy(dstTop,srcTop,bmp.GetWidth()*4); ARGB sucks.  Should be RGBA.
					for(x=0; x<bmp.GetWidth(); x++)
					{
						dstTop[x*4+3]=srcTop[x*4+3];
						dstTop[x*4+2]=srcTop[x*4+0];
						dstTop[x*4+1]=srcTop[x*4+1];
						dstTop[x*4+0]=srcTop[x*4+2];
					}
				}

				tex->UnlockRect(level);
				ysD3dDev->d3dDev->UpdateTexture(tex,texCopy);

				// if(D3DXCreateSprite(ysD3dDev->d3dDev,&sprite)==D3D_OK)
				{
					ysD3dDev->d3dSprite->Begin(D3DXSPRITE_ALPHABLEND);

					D3DXVECTOR3 pos;
					pos.x=(float)sx;
					pos.y=(float)sy;
					pos.z=0.0f;
					ysD3dDev->d3dSprite->Draw(texCopy,&rect,NULL,&pos,0xffffffff);

					ysD3dDev->d3dSprite->End();
					// sprite->Release();
				}
			}
			tex->Release();
			texCopy->Release();
		}
	}
}

void FsGuiCommonDrawing::DrawBmpArray(const YsBitmapArray &bmpAry,double x0,double y0)
{
	// 20 21 22  <- Some blank above.  Height of this row may be lower than other rows.
	// 10 11 12
	// 00 01 02  <- Packed from lower left.

	int lowY=(int)y0+bmpAry.GetTotalHeight();
	for(int i=0; i<bmpAry.GetNumBlockY(); ++i)
	{
		int nextLowY=lowY;
		for(int j=0; j<bmpAry.GetNumBlockX(); ++j)
		{
			const YsBitmap *bmp=bmpAry.GetTileBitmap(j,i);
			if(NULL!=bmp)
			{
				DrawBmp(*bmp,x0+j*(int)bmpAry.GetTileWidth(),lowY-(int)bmp->GetHeight());
			}
			nextLowY=lowY-(int)bmp->GetHeight();
		}
		lowY=nextLowY;
	}
}

void FsGuiCommonDrawing::DrawMask(const YsColor &fgCol,const YsColor & /*bgCol*/,double x0,double y0,double wid,double hei)
{
	if(ysD3dDev!=NULL)
	{
		int r,g,b;
		if(fgCol.Ri()>200 && fgCol.Gi()>200 && fgCol.Bi()>200)
		{
			r=32;
			g=32;
			b=32;
		}
		else
		{
			r=224;
			g=224;
			b=224;
		}

		ysD3dDev->d3dDev->SetRenderState(D3DRS_ALPHABLENDENABLE,TRUE);
		ysD3dDev->d3dDev->SetRenderState(D3DRS_SRCBLEND,D3DBLEND_SRCALPHA);
		ysD3dDev->d3dDev->SetRenderState(D3DRS_DESTBLEND,D3DBLEND_INVSRCALPHA);

		ysD3dDev->AddXyzCol(D3DPT_TRIANGLEFAN,x0    ,y0,    0.5,r,g,b,224);
		ysD3dDev->AddXyzCol(D3DPT_TRIANGLEFAN,x0+wid,y0,    0.5,r,g,b,224);
		ysD3dDev->AddXyzCol(D3DPT_TRIANGLEFAN,x0+wid,y0+hei,0.5,r,g,b,224);
		ysD3dDev->AddXyzCol(D3DPT_TRIANGLEFAN,x0    ,y0+hei,0.5,r,g,b,224);
		ysD3dDev->FlushXyzCol(D3DPT_TRIANGLEFAN);
	}
}

void FsGuiCommonDrawing::SetClipRect(double x0,double y0,double wid,double hei)
{
	RECT rc;
	rc.left=(LONG)x0;
	rc.top=(LONG)y0;
	rc.right=(LONG)(x0+wid)+1;
	rc.bottom=(LONG)(y0+hei)+1;
	ysD3dDev->d3dDev->SetScissorRect(&rc);

	ysD3dDev->d3dDev->SetRenderState(D3DRS_SCISSORTESTENABLE ,TRUE);
}

void FsGuiCommonDrawing::ClearClipRect(void)
{
	ysD3dDev->d3dDev->SetRenderState(D3DRS_SCISSORTESTENABLE ,FALSE);
}
