#include "fsgui3dapp.h"
#include "miscdlg.h"
#include <ysgl.h>
#include <ysglbuffer.h>

#include <ysshellext_diagnoseutil.h>
#include <ysshellextedit_boolutil.h>
#include <ysshellextedit_orientationutil.h>
#include <ysshellextedit_localop.h>

#include "booldialog.h"
#include "textresource.h"

#include "thread"

////////////////////////////////////////////////////////////

PolyCreBoolDialog::PolyCreBoolDialog()
{
	canvas=NULL;
	cancelBtn=NULL;
}

PolyCreBoolDialog::~PolyCreBoolDialog()
{
}

/*static*/ PolyCreBoolDialog *PolyCreBoolDialog::Create(class FsGui3DMainCanvas *canvas)
{
	PolyCreBoolDialog *dlg=new PolyCreBoolDialog;
	dlg->canvas=canvas;
	return dlg;
}

/*static*/ void PolyCreBoolDialog::Delete(PolyCreBoolDialog *ptr)
{
	delete ptr;
}

YSRESULT PolyCreBoolDialog::Make(void)
{
	if(NULL==cancelBtn)
	{
		FsGuiDialog::Initialize();

		AddStaticText(0,FSKEY_NULL,FSGUI_DLG_BOOL_CLICKONSHELL,YSTRUE);

		diagnoseBtn=AddTextButton(0,FSKEY_NULL,FSGUI_CHECKBOX,FSGUI_DLG_BOOL_DIAGNOSE,YSTRUE);
		recalcNormalBtn=AddTextButton(0,FSKEY_NULL,FSGUI_CHECKBOX,FSGUI_DLG_BOOL_RECALCNORMAL,YSTRUE);
		triangulateNonPlanarBtn=AddTextButton(0,FSKEY_NULL,FSGUI_CHECKBOX,FSGUI_DLG_BOOL_TRIANGULATENONPLANAR,YSTRUE);
		cancelBtn=AddTextButton(0,FSKEY_ESC,FSGUI_PUSHBUTTON,FSGUI_COMMON_CANCEL,YSTRUE);

		diagnoseBtn->SetCheck(YSTRUE);
		recalcNormalBtn->SetCheck(YSTRUE);
		triangulateNonPlanarBtn->SetCheck(YSTRUE);

		SetArrangeType(FSDIALOG_ARRANGE_TOP_LEFT);
		SetBackgroundAlpha(0.3);
		Fit();
	}

	return YSOK;
}

void PolyCreBoolDialog::RemakeDrawingBuffer(void)
{
	// As required
}

void PolyCreBoolDialog::OnButtonClick(FsGuiButton *btn)
{
	if(btn==cancelBtn)
	{
		canvas->Edit_ClearUIMode();
	}
}

void PolyCreBoolDialog::OnDropListSelChange(FsGuiDropList *,int)
{
}

void PolyCreBoolDialog::OnTextBoxChange(FsGuiTextBox *)
{
}

void PolyCreBoolDialog::OnSliderPositionChange(FsGuiSlider *,const double &,const double &)
{
}

////////////////////////////////////////////////////////////

/*static*/ void FsGui3DMainCanvas::BoolUnion(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	YsShellExtEdit *shl=canvas.slHd;
	if(NULL!=shl)
	{
		canvas.Edit_ClearUIMode();

		canvas.boolDlg->Make();
		canvas.AddDialog(canvas.boolDlg);
		canvas.ArrangeDialog();

		canvas.undoRedoRequireToClearUIMode=YSFALSE;
		canvas.deletionRequireToClearUIMode=YSFALSE;

		canvas.boolOpType=YSBOOLOR;
		canvas.LButtonCallBack=FsGui3DMainCanvas::Bool_LButtonCallBack;
	}
}

/*static*/ void FsGui3DMainCanvas::BoolSubtraction(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	YsShellExtEdit *shl=canvas.slHd;
	if(NULL!=shl)
	{
		canvas.Edit_ClearUIMode();

		canvas.boolDlg->Make();
		canvas.AddDialog(canvas.boolDlg);
		canvas.ArrangeDialog();

		canvas.undoRedoRequireToClearUIMode=YSFALSE;
		canvas.deletionRequireToClearUIMode=YSFALSE;

		canvas.boolOpType=YSBOOLMINUS;
		canvas.LButtonCallBack=FsGui3DMainCanvas::Bool_LButtonCallBack;
	}
}

/*static*/ void FsGui3DMainCanvas::BoolIntersection(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	YsShellExtEdit *shl=canvas.slHd;
	if(NULL!=shl)
	{
		canvas.Edit_ClearUIMode();

		canvas.boolDlg->Make();
		canvas.AddDialog(canvas.boolDlg);
		canvas.ArrangeDialog();

		canvas.undoRedoRequireToClearUIMode=YSFALSE;
		canvas.deletionRequireToClearUIMode=YSFALSE;

		canvas.boolOpType=YSBOOLAND;
		canvas.LButtonCallBack=FsGui3DMainCanvas::Bool_LButtonCallBack;
	}
}

/*static*/ void FsGui3DMainCanvas::BoolMerge(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	YsShellExtEdit *shl=canvas.slHd;
	if(NULL!=shl)
	{
		canvas.Edit_ClearUIMode();

		canvas.boolDlg->Make();
		canvas.AddDialog(canvas.boolDlg);
		canvas.ArrangeDialog();

		canvas.undoRedoRequireToClearUIMode=YSFALSE;
		canvas.deletionRequireToClearUIMode=YSFALSE;

		canvas.boolOpType=YSBOOLBLEND;
		canvas.LButtonCallBack=FsGui3DMainCanvas::Bool_LButtonCallBack;
	}
}

/*static*/ void FsGui3DMainCanvas::BoolSeparate(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	YsShellExtEdit *shl=canvas.slHd;
	if(NULL!=shl)
	{
		canvas.Edit_ClearUIMode();

		canvas.boolDlg->Make();
		canvas.AddDialog(canvas.boolDlg);
		canvas.ArrangeDialog();

		canvas.undoRedoRequireToClearUIMode=YSFALSE;
		canvas.deletionRequireToClearUIMode=YSFALSE;

		canvas.boolOpType=YSBOOLSEPARATE;
		canvas.LButtonCallBack=FsGui3DMainCanvas::Bool_LButtonCallBack;
	}
}

/*static*/ YSRESULT FsGui3DMainCanvas::Bool_LButtonCallBack(FsGui3DMainCanvas &canvas,YSBOOL,YSBOOL,YSBOOL,int mx,int my)
{
	YsShellDnmContainer <YsShellExtEdit>::Node *slHdB=canvas.PickedSlHd(mx,my,0,NULL);
	if(NULL!=slHdB && slHdB!=canvas.slHd)
	{
		canvas.boolDlg->slHdB=slHdB;
		if(YSTRUE!=canvas.boolDlg->diagnoseBtn->GetCheck())
		{
			return canvas.Bool_Apply(canvas.boolOpType,*canvas.slHd,*slHdB);
		}
		else
		{
			canvas.Bool_DiagnoseDialog();
			return YSOK;
		}
	}
	return YSERR;
}

static void DiagnoseCallBack(YsShellExt_DiagnoseUtil *util)
{
	util->CheckSelfIntersection();
	util->CheckNonManifoldEdge();
}

void FsGui3DMainCanvas::Bool_DiagnoseDialog(void)
{
	YsShellExt_DiagnoseUtil diagA,diagB;
	diagA.SetShell(slHd->Conv());
	diagB.SetShell(boolDlg->slHdB->Conv());

	diagA.SetNumThread(2);
	diagB.SetNumThread(2);

	diagA.debug_threadId=0;
	diagB.debug_threadId=1;

	std::thread t1(DiagnoseCallBack,&diagA);
	std::thread t2(DiagnoseCallBack,&diagB);
	t1.join();
	t2.join();

	YSBOOL defect=YSFALSE;
	YsWString msg;
	msg.Set(FSGUI_DLG_BOOL_POTENTIALPROBLEMS);
	msg.Append(L"\n");
	if(0<diagA.nonManifoldEdgeArray.GetN() || 0<diagA.selfIntersectionArray.GetN())
	{
		msg.Append(FSGUI_DLG_BOOL_CURRENTSHELL);
		msg.Append(L"\n");
		defect=YSTRUE;
	}
	if(0<diagA.nonManifoldEdgeArray.GetN())
	{
		msg.Append(FSGUI_DLG_BOOL_NONMANIFOLD);
		msg.Append(L"\n");
		defect=YSTRUE;
	}
	if(0<diagA.selfIntersectionArray.GetN())
	{
		msg.Append(FSGUI_DLG_BOOL_SELFINTERSECTION);
		msg.Append(L"\n");
		defect=YSTRUE;
	}

	if(0<diagB.nonManifoldEdgeArray.GetN() || 0<diagB.selfIntersectionArray.GetN())
	{
		msg.Append(FSGUI_DLG_BOOL_PICKEDSHELL);
		msg.Append(L"\n");
		defect=YSTRUE;
	}
	if(0<diagB.nonManifoldEdgeArray.GetN())
	{
		msg.Append(FSGUI_DLG_BOOL_NONMANIFOLD);
		msg.Append(L"\n");
		defect=YSTRUE;
	}
	if(0<diagB.selfIntersectionArray.GetN())
	{
		msg.Append(FSGUI_DLG_BOOL_SELFINTERSECTION);
		msg.Append(L"\n");
		defect=YSTRUE;
	}

	if(YSTRUE==defect)
	{
		msg.Append(L"\n");
		msg.Append(FSGUI_DLG_BOOL_DEFECTEXPLANATION);
		YesNoDialog(FSGUI_DLG_BOOL_DEFECTFOUND,msg,FSGUI_COMMON_YES,FSGUI_COMMON_NO,Bool_DiagnoseDialogCallBack);
	}
	else
	{
		Bool_Apply(boolOpType,*slHd,*(boolDlg->slHdB));
	}
}

/*static*/ void FsGui3DMainCanvas::Bool_DiagnoseDialogCallBack(FsGuiControlBase *appPtr,FsGuiDialog *,int returnValue)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	if(YSOK==(YSRESULT)returnValue)
	{
		canvas.Bool_Apply(canvas.boolOpType,*canvas.slHd,*(canvas.boolDlg->slHdB));
	}
	else
	{
		canvas.Edit_ClearUIMode();
	}
}

static void FixOrientationHook(void *ptr)
{
	YsShellExtEdit *shl=(YsShellExtEdit *)ptr;
	YsShellExtEdit_OrientationUtil::FixOrientationOfClosedSolid(*shl);
}

static void TriangulationHook(void *ptr)
{
	YsShellExtEdit *shl=(YsShellExtEdit *)ptr;
	YsShellExt_DiagnoseUtil util;
	util.SetNumThread(2);
	util.SetShell(shl->Conv());
	util.CheckNonPlanarPolygon();
	for(auto &nonPlanarPolygon : util.nonPlanarPolygonArray)
	{
		YsShellExtEdit_TriangulatePolygon(*shl,nonPlanarPolygon.plHd);
	}
}

YSRESULT FsGui3DMainCanvas::Bool_Apply(YSBOOLEANOPERATION boolOpType,YsShellExtEdit &slHdA,YsShellExtEdit &slHdB)
{
	YsShellExtEdit_BooleanUtil boolUtil;

	YsShellExtEdit::StopIncUndo incUndoA(&slHdA);
	YsShellExtEdit::StopIncUndo incUndoB(&slHdB);

	if(YSTRUE==boolDlg->triangulateNonPlanarBtn->GetCheck())
	{
		std::thread t1(TriangulationHook,&slHdA);
		std::thread t2(TriangulationHook,&slHdB);
		t1.join();
		t2.join();
	}

	if(YSTRUE==boolDlg->recalcNormalBtn->GetCheck())
	{
		std::thread t1(FixOrientationHook,&slHdA);
		std::thread t2(FixOrientationHook,&slHdB);
		t1.join();
		t2.join();
	}

	boolUtil.SetShellAndOpType((YsShellExtEdit &)slHdA,(YsShellExtEdit &)slHdB,boolOpType);
	boolUtil.Run();

	boolUtil.MakeVertexMapping(0);  // Also tentatively mark vertices from the other shell as 'used'.
	boolUtil.CacheUnusedPolygon(0);
	boolUtil.TransferRemainingPartOfConstEdge(0);
	boolUtil.ReconstructConstEdge(0);
	boolUtil.CombineConstEdgeOfSameOrigin(0);
	boolUtil.ConstrainBetweenInputShell(0);
	boolUtil.DeleteTemporaryVertex(0);
	boolUtil.MergePolygonFromSameOriginLeavingOneShortestEdgePerVertex(0);
	boolUtil.AddPolygonFromTheOtherShell(0);

	if(YSBOOLSEPARATE==boolOpType)
	{
		boolUtil.MakeVertexMapping(1);  // Also tentatively mark vertices from the other shell as 'used'.
		boolUtil.CacheUnusedPolygon(1);
		boolUtil.TransferRemainingPartOfConstEdge(1);
		boolUtil.ReconstructConstEdge(1);
		boolUtil.CombineConstEdgeOfSameOrigin(1);
		boolUtil.ConstrainBetweenInputShell(1);
		boolUtil.DeleteTemporaryVertex(1);
		boolUtil.MergePolygonFromSameOriginLeavingOneShortestEdgePerVertex(1);
		boolUtil.AddPolygonFromTheOtherShell(1);
	}

	boolUtil.ModifyShell(0);
	boolUtil.ApplyConstEdgeChange(0);
	boolUtil.DeleteCachedUnusedPolygon(0);
	boolUtil.DeleteUsedVertexTurnedUnused(0);

	if(YSBOOLSEPARATE==boolOpType)
	{
		boolUtil.ModifyShell(1);
		boolUtil.ApplyConstEdgeChange(1);
		boolUtil.DeleteCachedUnusedPolygon(1);
		boolUtil.DeleteUsedVertexTurnedUnused(1);
	}

	needRemakeDrawingBuffer=(unsigned int)NEED_REMAKE_DRAWING_ALL;
	needRemakeDrawingBuffer_for_OtherShell=(unsigned int)NEED_REMAKE_DRAWING_ALL;
	SetNeedRedraw(YSTRUE);

	Edit_ClearUIMode();

	return YSERR;
}



