#include "../fsgui3dapp.h"
#include "../textresource.h"
#include "dnmtreedialog.h"



PolyCreDnmTreeDialog::PolyCreDnmTreeDialog()
{
	dnmTree=NULL;
	canvas=NULL;
	okBtn=NULL;
	cancelBtn=NULL;
}

PolyCreDnmTreeDialog::~PolyCreDnmTreeDialog()
{
}

/*static*/ PolyCreDnmTreeDialog *PolyCreDnmTreeDialog::Create(class FsGui3DMainCanvas *canvas)
{
	PolyCreDnmTreeDialog *dlg=new PolyCreDnmTreeDialog;
	dlg->canvas=canvas;
	return dlg;
}

/*static*/ void PolyCreDnmTreeDialog::Delete(PolyCreDnmTreeDialog *ptr)
{
	delete ptr;
}

YSRESULT PolyCreDnmTreeDialog::Make(void)
{
	if(NULL==okBtn)
	{
		FsGuiDialog::Initialize();

		okBtn=AddTextButton(0,FSKEY_ENTER,FSGUI_PUSHBUTTON,FSGUI_COMMON_OK,YSTRUE);
		cancelBtn=AddTextButton(0,FSKEY_ESC,FSGUI_PUSHBUTTON,FSGUI_COMMON_CANCEL,YSFALSE);

		dnmTree=AddTreeControl(0,FSKEY_NULL,32,24,YSTRUE);

		SetArrangeType(FSDIALOG_ARRANGE_TOP_LEFT);
		SetBackgroundAlpha(0.3);
		Fit();
	}

	dnmTree->CleanUp();
	auto rootArray=canvas->shlGrp.GetRootNodeArray();
	for(auto rootNode : rootArray)
	{
		PopulateTreeControl(dnmTree->GetRoot(),rootNode);
	}

	return YSOK;
}

void PolyCreDnmTreeDialog::PopulateTreeControl(const FsGuiTreeControlNode *parent,YsShellDnmContainer <YsShellExtEdit>::Node *dnmNode)
{
	auto newNode=dnmTree->AddTextChild(parent,dnmNode->nodeName);
	for(auto childNode : dnmNode->children)
	{
		PopulateTreeControl(newNode,childNode);
	}
}

void PolyCreDnmTreeDialog::RemakeDrawingBuffer(void)
{
	// As required
}

void PolyCreDnmTreeDialog::OnButtonClick(FsGuiButton *btn)
{
	if(btn==okBtn)
	{
	}
	else if(btn==cancelBtn)
	{
		canvas->Edit_ClearUIMode();
	}
}

void PolyCreDnmTreeDialog::OnDropListSelChange(FsGuiDropList *drp,int)
{
}

void PolyCreDnmTreeDialog::OnTextBoxChange(FsGuiTextBox *txt)
{
}

void PolyCreDnmTreeDialog::OnSliderPositionChange(FsGuiSlider *slider,const double &prevPos,const double &prevValue)
{
}
