#ifndef EDIT_INTERSECTIONDIALOG_IS_INCLUDED
#define EDIT_INTERSECTIONDIALOG_IS_INCLUDED
/* { */

#include <fsgui.h>
#include <ysshellext_intersectionutil.h>

class PolyCreChopOffDialog : public FsGuiDialog
{
private:
	class FsGui3DMainCanvas *canvas;
	FsGuiButton *okBtn,*cancelBtn;

public:
	FsGuiDropList *wholeModelOrLocalDrp;
	FsGuiDropList *cutPlnDrp,*whichSideDrp;
	FsGuiButton *copyToCutBuffer;

	YsShellExt_CutByPlaneUtil cutByPlaneUtil;
	YsGLVertexBuffer markerVtxBuffer;
	YsGLPixOffsetBuffer markerOffsetBuffer;

private:
	PolyCreChopOffDialog();
	~PolyCreChopOffDialog();
public:
	static PolyCreChopOffDialog *Create(class FsGui3DMainCanvas *canvas);
	static void Delete(PolyCreChopOffDialog *ptr);

	YSRESULT Make(void);
	YSRESULT GetCuttingPlane(YsPlane &pln,YSBOOL showError) const;
	YSRESULT GetCuttingPolygon(YsArray <YsShellVertexHandle> &plVtPos,YSBOOL showError) const;
	YSRESULT GetCuttingPolygon(YsArray <YsVec3> &plVtPos,YSBOOL showError) const;
	YsShellVertexHandle GetSideVertex(YSBOOL showError) const;
	YSRESULT SetUpIntersectionUtil(YSBOOL showErrorMessage);
	void RemakeDrawingBuffer(void);

	virtual void OnButtonClick(FsGuiButton *btn);
	virtual void OnDropListSelChange(FsGuiDropList *drp,int);
	virtual void OnTextBoxChange(FsGuiTextBox *txt);
	virtual void OnSliderPositionChange(FsGuiSlider *slider,const double &prevPos,const double &prevValue);
};

/* } */
#endif
