/* ////////////////////////////////////////////////////////////

  File Name: ysshellextedit_orientationutil.h
  Copyright (c) 2014 Soji Yamakawa.  All rights reserved.
  http://www.ysflight.com

//////////////////////////////////////////////////////////// */

#ifndef YSSHELLEXTEDIT_ORIENTATIONUTIL_IS_INCLUDED
#define YSSHELLEXTEDIT_ORIENTATIONUTIL_IS_INCLUDED
/* { */

#include "ysshellext_orientationutil.h"
#include <ysshellextedit.h>

class YsShellExtEdit_OrientationUtil : private YsShellExt_OrientationUtil
{
public:
	YsShellExtEdit_OrientationUtil();
	~YsShellExtEdit_OrientationUtil();

	/*! This function re-calculates the normal of polygon plHd. */
	YSRESULT RecalculateNormal(YsShellExtEdit &shl,YsShellPolygonHandle plHd);

	/*! This function re-calculates the normal of polygon plHd. */
	template <const int N>
	YSRESULT RecalculateNormal(YsShellExtEdit &shl,const YsArray <YsShellPolygonHandle,N> &plHdArray);

	/*! This function fixes normal vectors of the polygons of the given shell 'shl' 
	    assuming that the shell is a closed manifold solid. */
	static void FixOrientationOfClosedSolid(YsShellExtEdit &shl);
};

template <const int N>
YSRESULT YsShellExtEdit_OrientationUtil::RecalculateNormal(YsShellExtEdit &shl,const YsArray <YsShellPolygonHandle,N> &plHdArray)
{
	YsShellExtEdit::StopIncUndo incUndo(shl);

	for(YsShellPolygonHandle plHd : plHdArray)
	{
		RecalculateNormal(shl,plHd);
	}
	return YSOK;
}

/* } */
#endif
