uniform "YS_GLSL_MIDP" float radius1;
uniform "YS_GLSL_MIDP" float radius2;
uniform "YS_GLSL_MIDP" float maxIntensity;
uniform "YS_GLSL_MIDP" float angleInterval;
uniform "YS_GLSL_MIDP" float angleOffset;
uniform "YS_GLSL_MIDP" float exponent;

varying "YS_GLSL_LOWP" vec2 uv;
varying "YS_GLSL_LOWP" vec4 color;

// No alpha cut off in the flash renderer.
#include "YS_GLSL_FOG_VARIABLES.glsl"

void main()
{
	const "YS_GLSL_MIDP" float PI=3.1415927;
	const "YS_GLSL_MIDP" float halfPI=3.1415927/2.0;
	const "YS_GLSL_MIDP" float twoPI=3.1415927*2.0;
	"YS_GLSL_MIDP" float r=length(uv);
	if(r<=radius1)
	{
		"YS_GLSL_MIDP" float param=halfPI*(radius1-r)/radius1;
		"YS_GLSL_MIDP" float additive=sin(param)*maxIntensity;
		gl_FragColor[0]=min(1.0,color[0]+additive);
		gl_FragColor[1]=min(1.0,color[1]+additive);
		gl_FragColor[2]=min(1.0,color[2]+additive);
		gl_FragColor[3]=color[3];

		#include "YS_GLSL_FOGCALCULATION_IN_FRAGMENTSHADER.glsl"
	}
	else
	{
		"YS_GLSL_MIDP" float halfInterval=angleInterval/2.0;
		"YS_GLSL_MIDP" float theata=twoPI+angleOffset+atan(uv.y,uv.x);
		"YS_GLSL_MIDP" float t=mod(theata,angleInterval);
		"YS_GLSL_MIDP" float s=1.0-abs(t-halfInterval)/halfInterval;

		"YS_GLSL_MIDP" float rf=radius1+(radius2-radius1)*pow(s,exponent);
		if(rf<r)
		{
			discard;
		}
		else
		{
			"YS_GLSL_MIDP" float alpha=max(1.0-(r-radius1)/(rf-radius1),0.0);
			gl_FragColor[0]=color[0];
			gl_FragColor[1]=color[1];
			gl_FragColor[2]=color[2];
			gl_FragColor[3]=color[3]*alpha;

			#include "YS_GLSL_FOGCALCULATION_IN_FRAGMENTSHADER.glsl"
		}
    }
}
