uniform mat4 projection;
uniform mat4 modelView;
uniform "YS_GLSL_MIDP" float dimension;
uniform "YS_GLSL_MIDP" float radius1;
uniform "YS_GLSL_MIDP" float radius2;
uniform "YS_GLSL_MIDP" float maxIntensity;
uniform "YS_GLSL_MIDP" float angleInterval;
uniform "YS_GLSL_MIDP" float angleOffset;
uniform "YS_GLSL_MIDP" float exponent;

attribute "YS_GLSL_HIGHP" vec3 vertex;
attribute "YS_GLSL_LOWP" vec4 colorIn;
attribute "YS_GLSL_HIGHP" vec3 viewOffset;

varying "YS_GLSL_LOWP" vec2 uv;
varying "YS_GLSL_LOWP" vec4 color;

#include "YS_GLSL_ZOFFSET_VARIABLE.glsl"
#include "YS_GLSL_FOG_VARIABLES.glsl"

void main()
{
	#include "YS_GLSL_VIEW_TRANSFORM_IN_VERTEX_SHADER.glsl"

	vec3 offset=viewOffset*dimension;
	vertexInView.x+=offset.x;
	vertexInView.y+=offset.y;
	vertexInView.z+=offset.z;

	#include "YS_GLSL_FOG_CALCULATION_IN_VERTEXSHADER.glsl"
	#include "YS_GLSL_PROJECTION_TRANSFORM_IN_VERTEX_SHADER.glsl"

	uv=vec2(viewOffset.x,viewOffset.y);
	color=colorIn;

	#include "YS_GLSL_ZOFFSET_IN_VERTEXSHADER.glsl"
}
