uniform mat4 projection;
uniform mat4 modelView;

uniform bool lightEnabled[YSGLSL_MAX_NUM_LIGHT];
uniform vec4 lightPos[YSGLSL_MAX_NUM_LIGHT];
uniform vec3 lightColor[YSGLSL_MAX_NUM_LIGHT];
uniform vec3 specularColor;
uniform float specularExponent;
uniform vec3 ambientColor;
uniform "YS_GLSL_LOWP"vec4 color;

attribute "YS_GLSL_HIGHP" vec3 vertex;
attribute "YS_GLSL_HIGHP" vec3 normal;

varying "YS_GLSL_LOWP" vec4 colorOut;

#include "YS_GLSL_TEXTURE_VARIABLE.glsl"
#include "YS_GLSL_ZOFFSET_VARIABLE.glsl"
#include "YS_GLSL_FOG_VARIABLES.glsl"

void main()
{
	#include "YS_GLSL_VIEW_TRANSFORM_IN_VERTEX_SHADER.glsl"
	#include "YS_GLSL_PROJECTION_TRANSFORM_IN_VERTEX_SHADER.glsl"

	"YS_GLSL_HIGHP" vec3 nomLocal=normalize((modelView*vec4(normal,0)).xyz);
	"YS_GLSL_HIGHP" vec3 vecToCamera=-normalize(vertexInView.xyz);

	#include "YS_GLSL_STANDARD_LIGHTING.glsl"

	colorOut=vec4(accumColor,color[3]);

	#include "YS_GLSL_TEXTURE_IN_VERTEXSHADER.glsl"
	#include "YS_GLSL_FOG_CALCULATION_IN_VERTEXSHADER.glsl"
	#include "YS_GLSL_ZOFFSET_IN_VERTEXSHADER.glsl"
}
