uniform bool lightEnabled[YSGLSL_MAX_NUM_LIGHT];
uniform "YS_GLSL_HIGHP"vec4 lightPos[YSGLSL_MAX_NUM_LIGHT];
uniform "YS_GLSL_LOWP"vec3 lightColor[YSGLSL_MAX_NUM_LIGHT];
uniform "YS_GLSL_LOWP"vec3 specularColor;
uniform "YS_GLSL_LOWP"float specularExponent;
uniform "YS_GLSL_LOWP"vec3 ambientColor;
uniform sampler2D textureIdent;

varying "YS_GLSL_HIGHP" vec3 normalOut;
varying "YS_GLSL_HIGHP" vec3 vecToCameraOut;
varying "YS_GLSL_LOWP" vec4 color;
varying "YS_GLSL_HIGHP" vec3 texCoordOut;

#include "YS_GLSL_ALPHA_CUTOFF_PARAMETER.glsl"
#include "YS_GLSL_FOG_VARIABLES.glsl"

void main()
{
	"YS_GLSL_HIGHP"vec3 nomLocal=normalize(normalOut);
	"YS_GLSL_HIGHP"vec3 vecToCamera=normalize(vecToCameraOut);

	#include "YS_GLSL_STANDARD_LIGHTING.glsl"

	gl_FragColor=vec4(accumColor,color[3]);

	"YS_GLSL_LOWP" vec4 texcell=texture2D(textureIdent,texCoordOut.xy);
	gl_FragColor=gl_FragColor*texcell;

	#include "YS_GLSL_ALPHA_CUTOFF_IN_FRAGMENT_SHADER.glsl"
	#include "YS_GLSL_FOGCALCULATION_IN_FRAGMENTSHADER.glsl"
}
