#include <ysclass.h>
#include "../ysfileinfo.h"
#include "../ysencoding.h"

#include <stdio.h>
#include <stdlib.h>

#include <dirent.h>
#include <unistd.h>
#include <sys/stat.h>


YSRESULT YsFileList::FindFileList(const wchar_t path[],const wchar_t prefix[],const wchar_t postfix[])
{
	YsString cPath,cPrefix,cPostfix;
	YsUnicodeToSystemEncoding(cPath,path);
	YsUnicodeToSystemEncoding(cPrefix,prefix);
	YsUnicodeToSystemEncoding(cPostfix,postfix);
	return FindFileList(cPath,cPrefix,cPostfix);
}

YSRESULT YsFileList::FindFileList(const char path[],const char prefix[],const char postfix[])
{
	YsString pathForOpen(path);
	if(1<pathForOpen.Strlen() && 
       (pathForOpen.LastChar()=='/' || pathForOpen.LastChar()=='\\'))
	{
		pathForOpen.BackSpace();
	}


	DIR *dp;
	if(NULL==(dp=opendir(pathForOpen)))
	{
		return YSERR;
	}


	if(NULL!=prefix)
	{
		YsSystemEncodingToUnicode(uPrefix,prefix);
	}
	else
	{
		uPrefix.Set(L"");
	}
	if(NULL!=postfix)
	{
		YsSystemEncodingToUnicode(uPostfix,postfix);
	}
	else
	{
		uPostfix.Set(L"");
	}
	uPrefix.Uncapitalize();
	uPostfix.Uncapitalize();

	CleanUp();
	YsSystemEncodingToUnicode(this->path,path);
	
	struct dirent *de;
	while(NULL!=(de=readdir(dp)))
	{
		if(0!=de->d_ino && 0!=strcmp(de->d_name,".") && 0!=strcmp(de->d_name,".."))
		{
			YsString ful;
			ful.MakeFullPathName(path,de->d_name);

			struct stat st;
			stat(ful,&st);

			YSBOOL isDir=YSFALSE;
			unsigned long sizeHigh=0;
			unsigned long sizeLow=0;

			if(S_IFDIR==(st.st_mode&S_IFMT))
			{
				isDir=YSTRUE;
			}
			else
			{
				isDir=YSFALSE;
				unsigned long long fileSize=st.st_size;
				sizeHigh=(fileSize>>32)&0x7fffffff;
				sizeLow=(fileSize)&0xffffffff;
			}

			YsWString wName;
			YsSystemEncodingToUnicode(wName,de->d_name);
			TestAndAddFileInfo(wName,isDir,sizeHigh,sizeLow);
		}
	}
	return YSOK;
}
