#include "../ysfileio.h"

#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>

const char *YsFileIO::Getcwd(YsString &cwd)
{
	char cwdIn[1024];
	getcwd(cwdIn,1024);
	cwd.Set(cwdIn);
	return cwd;
}

const wchar_t *YsFileIO::Getcwd(YsWString &cwd)
{
	char cwdIn[1024];
	getcwd(cwdIn,1024);
	cwd.SetUTF8String(cwdIn);
	return cwd;
}

YSRESULT YsFileIO::ChDir(const char dirName[])
{
	if(0==chdir(dirName))
	{
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsFileIO::ChDir(const wchar_t dirName[])
{
	YsString utf8;
	utf8.EncodeUTF8(dirName);
	return ChDir(utf8.Txt());  // Hope the system supports UTF8 file name.
}

YSRESULT YsFileIO::MkDir(const char dirName[])
{
	if(0==mkdir(dirName,0755))
	{
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsFileIO::MkDir(const wchar_t dirName[])
{
	YsString utf8;
	utf8.EncodeUTF8(dirName);
	return MkDir(utf8.Txt());  // Hope the system supports UTF8 file name.
}

FILE *YsFileIO::Fopen(const wchar_t fn[],const char mode[])
{
	YsString fnUTF8,modeUTF8;
	fnUTF8.EncodeUTF8 <wchar_t> (fn);
	return fopen(fnUTF8,mode);
}

FILE *YsFileIO::Fopen(const char fn[],const char mode[])
{
	return fopen(fn,mode);
}

YSRESULT YsFileIO::Remove(const wchar_t fn[])
{
	YsString fnUTF8;
	fnUTF8.EncodeUTF8 <wchar_t> (fn);
	if(0==remove(fnUTF8))
	{
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsFileIO::Remove(const char fn[])
{
	if(0==remove(fn))
	{
		return YSOK;
	}
	return YSERR;
}
