#ifndef YSSPECIALPATH_IS_INCLUDED
#define YSSPECIALPATH_IS_INCLUDED
/* { */

#include <ysclass.h>


// Examples:
// [UserDir]
//   Windows C:\Users\soji
//   Linux   
//   MacOSX  
// [UserDocDir]
//   Windows C:\Users\soji\My Documents
//   Linux   ~/Documents
//   MacOSX  
// [UserAppDataDir]
//   Windows C:\Users\soji\Application Data
//   Linux   ~/ApplicationData (I made up)
//   MacOSX  ~/Library/Application Support
// [AllUsersDir]
//   Windows C:\Users\All Users\Application Data
//   Linux   No such thing (returns YSERR)
//   MacOSX  Does it exist?

// GetProgramBaseDir will return the directory where the executable files are stored in Windows and Linux,
// the bundle directory in MacOSX.

class YsSpecialPath
{
	enum
	{
		MaxPath=512
	};

public:
	static YSRESULT GetProgramFileName(YsString &path);
	static YSRESULT GetProgramBaseDir(YsString &path);
	static YSRESULT GetUserDir(YsString &path);
	static YSRESULT GetUserDocDir(YsString &path);
	static YSRESULT GetUserAppDataDir(YsString &path);
	static YSRESULT GetAllUsersDir(YsString &path);

	static YSRESULT GetProgramFileName(YsWString &wpath);
	static YSRESULT GetProgramBaseDir(YsWString &wpath);
	static YSRESULT GetUserDir(YsWString &wpath);
	static YSRESULT GetUserDocDir(YsWString &wpath);
	static YSRESULT GetUserAppDataDir(YsWString &wpath);
	static YSRESULT GetAllUsersDir(YsWString &wpath);

	static YSRESULT GetProgramFileNameUTF8(YsString &path);
	static YSRESULT GetProgramBaseDirUTF8(YsString &path);
	static YSRESULT GetUserDirUTF8(YsString &path);
	static YSRESULT GetUserDocDirUTF8(YsString &path);
	static YSRESULT GetUserAppDataDirUTF8(YsString &path);
	static YSRESULT GetAllUsersDirUTF8(YsString &path);
};


/* } */
#endif
